"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("devtools/client/shared/vendor/react"));

var _reactDomFactories = require("devtools/client/shared/vendor/react-dom-factories");

var _reactPropTypes = _interopRequireDefault(require("devtools/client/shared/vendor/react-prop-types"));

var _reactRedux = require("devtools/client/shared/vendor/react-redux");

var _index = _interopRequireDefault(require("../../actions/index"));

loader.lazyRequireGetter(this, "_index2", "devtools/client/debugger/src/selectors/index");
loader.lazyRequireGetter(this, "_source", "devtools/client/debugger/src/utils/source");
loader.lazyRequireGetter(this, "_index3", "devtools/client/debugger/src/components/shared/Button/index");

var _AccessibleImage = _interopRequireDefault(require("../shared/AccessibleImage"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at <http://mozilla.org/MPL/2.0/>. */
const classnames = require("resource://devtools/client/shared/classnames.js");

class SourceFooter extends _react.PureComponent {
  static get propTypes() {
    return {
      canPrettyPrint: _reactPropTypes.default.bool.isRequired,
      prettyPrintMessage: _reactPropTypes.default.string.isRequired,
      endPanelCollapsed: _reactPropTypes.default.bool.isRequired,
      horizontal: _reactPropTypes.default.bool.isRequired,
      jumpToMappedLocation: _reactPropTypes.default.func.isRequired,
      mappedSource: _reactPropTypes.default.object,
      selectedSource: _reactPropTypes.default.object,
      selectedLocation: _reactPropTypes.default.object,
      isSelectedSourceBlackBoxed: _reactPropTypes.default.bool.isRequired,
      sourceLoaded: _reactPropTypes.default.bool.isRequired,
      toggleBlackBox: _reactPropTypes.default.func.isRequired,
      togglePaneCollapse: _reactPropTypes.default.func.isRequired,
      prettyPrintAndSelectSource: _reactPropTypes.default.func.isRequired,
      isSourceOnIgnoreList: _reactPropTypes.default.bool.isRequired
    };
  }

  prettyPrintButton() {
    const {
      selectedSource,
      canPrettyPrint,
      prettyPrintMessage,
      prettyPrintAndSelectSource,
      sourceLoaded
    } = this.props;

    if (!selectedSource) {
      return null;
    }

    if (!sourceLoaded && selectedSource.isPrettyPrinted) {
      return (0, _reactDomFactories.div)({
        className: "action",
        key: "pretty-loader"
      }, _react.default.createElement(_AccessibleImage.default, {
        className: "loader spin"
      }));
    }

    const type = "prettyPrint";
    return (0, _reactDomFactories.button)({
      onClick: () => {
        if (!canPrettyPrint) {
          return;
        }

        prettyPrintAndSelectSource(selectedSource);
      },
      className: classnames("action", type, {
        active: sourceLoaded && canPrettyPrint,
        pretty: (0, _source.isPretty)(selectedSource)
      }),
      key: type,
      title: prettyPrintMessage,
      "aria-label": prettyPrintMessage,
      disabled: !canPrettyPrint
    }, _react.default.createElement(_AccessibleImage.default, {
      className: type
    }));
  }

  blackBoxButton() {
    const {
      selectedSource,
      isSelectedSourceBlackBoxed,
      toggleBlackBox,
      sourceLoaded,
      isSourceOnIgnoreList
    } = this.props;

    if (!selectedSource || !(0, _source.shouldBlackbox)(selectedSource)) {
      return null;
    }

    let tooltip = isSelectedSourceBlackBoxed ? L10N.getStr("sourceFooter.unignore") : L10N.getStr("sourceFooter.ignore");

    if (isSourceOnIgnoreList) {
      tooltip = L10N.getStr("sourceFooter.ignoreList");
    }

    const type = "black-box";
    return (0, _reactDomFactories.button)({
      onClick: () => toggleBlackBox(selectedSource),
      className: classnames("action", type, {
        active: sourceLoaded,
        blackboxed: isSelectedSourceBlackBoxed || isSourceOnIgnoreList
      }),
      key: type,
      title: tooltip,
      "aria-label": tooltip,
      disabled: isSourceOnIgnoreList
    }, _react.default.createElement(_AccessibleImage.default, {
      className: "blackBox"
    }));
  }

  renderToggleButton() {
    if (this.props.horizontal) {
      return null;
    }

    return _react.default.createElement(_index3.PaneToggleButton, {
      key: "toggle",
      collapsed: this.props.endPanelCollapsed,
      horizontal: this.props.horizontal,
      handleClick: this.props.togglePaneCollapse,
      position: "end"
    });
  }

  renderCommands() {
    const commands = [this.blackBoxButton(), this.prettyPrintButton()].filter(Boolean);
    return commands.length ? (0, _reactDomFactories.div)({
      className: "commands"
    }, commands) : null;
  }

  renderSourceSummary() {
    const {
      mappedSource,
      jumpToMappedLocation,
      selectedLocation
    } = this.props;

    if (!mappedSource) {
      return null;
    }

    const tooltip = L10N.getFormatStr(mappedSource.isOriginal ? "sourceFooter.mappedOriginalSource.tooltip" : "sourceFooter.mappedGeneratedSource.tooltip", mappedSource.url);
    const filename = (0, _source.getFilename)(mappedSource);
    const label = L10N.getFormatStr(mappedSource.isOriginal ? "sourceFooter.mappedOriginalSource.title" : "sourceFooter.mappedGeneratedSource.title", filename);
    return (0, _reactDomFactories.button)({
      className: "mapped-source",
      onClick: () => jumpToMappedLocation(selectedLocation),
      title: tooltip
    }, (0, _reactDomFactories.span)(null, label));
  }

  renderCursorPosition() {
    // When we open a new source, there is no particular location selected and the line will be set to zero or falsy
    if (!this.props.selectedLocation || !this.props.selectedLocation.line) {
      return null;
    } // Note that line is 1-based while column is 0-based.


    const {
      line,
      column
    } = this.props.selectedLocation;
    const text = L10N.getFormatStr("sourceFooter.currentCursorPosition", line, column + 1);
    const title = L10N.getFormatStr("sourceFooter.currentCursorPosition.tooltip", line, column + 1);
    return (0, _reactDomFactories.div)({
      className: "cursor-position",
      title
    }, text);
  }

  render() {
    return (0, _reactDomFactories.div)({
      className: "source-footer"
    }, (0, _reactDomFactories.div)({
      className: "source-footer-start"
    }, this.renderCommands()), (0, _reactDomFactories.div)({
      className: "source-footer-end"
    }, this.renderSourceSummary(), this.renderCursorPosition(), this.renderToggleButton()));
  }

}

const mapStateToProps = state => {
  const selectedSource = (0, _index2.getSelectedSource)(state);
  const selectedLocation = (0, _index2.getSelectedLocation)(state);
  const sourceTextContent = (0, _index2.getSelectedSourceTextContent)(state);
  return {
    selectedSource,
    selectedLocation,
    isSelectedSourceBlackBoxed: selectedSource ? (0, _index2.isSourceBlackBoxed)(state, selectedSource) : null,
    isSourceOnIgnoreList: (0, _index2.isSourceMapIgnoreListEnabled)(state) && (0, _index2.isSourceOnSourceMapIgnoreList)(state, selectedSource),
    sourceLoaded: !!sourceTextContent,
    mappedSource: (0, _index2.getSelectedMappedSource)(state),
    prettySource: (0, _index2.getPrettySource)(state, selectedSource ? selectedSource.id : null),
    endPanelCollapsed: (0, _index2.getPaneCollapse)(state, "end"),
    canPrettyPrint: selectedLocation ? (0, _index2.canPrettyPrintSource)(state, selectedLocation) : false,
    prettyPrintMessage: selectedLocation ? (0, _index2.getPrettyPrintMessage)(state, selectedLocation) : null
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, {
  prettyPrintAndSelectSource: _index.default.prettyPrintAndSelectSource,
  toggleBlackBox: _index.default.toggleBlackBox,
  jumpToMappedLocation: _index.default.jumpToMappedLocation,
  togglePaneCollapse: _index.default.togglePaneCollapse
})(SourceFooter);

exports.default = _default;